#include <stdio.h>
#include <stdlib.h>

int main()
{
     long int h,n,i,j;
    scanf("%li %li", &h, &n);
    int m[h][n],f[h+1][n];
    for(i=0; i<h; i++)
    {
        for(j=0; j<n; j++)
        {
            scanf("%d", &m[i][j]);
        }
    }

    for(i=0; i<(h+1); i++)
    {
        for(j=0; j<n; j++)
        {
            f[i][j]=0;
        }
    }

    for(i=0; i<n; i++)
    {
        f[0][i]=1;
    }

    int bal=0, maradek=0,jobbra=0, balra=0;
     for(i=0; i<h; i++)
    {
        bal=-1;
        maradek=0;
        for(j=0; j<n; j++)
        {
            if(m[i][j]==1)
            {
                bal=j;
                f[i+1][j]+= f[i][j]+maradek;
                maradek=0;
            }
            else{
                jobbra=f[i][j]/2;
                balra=f[i][j]/2;
                if(f[i][j]%2==1)
                {
                    if((i%2)==0)
                    {
                        balra++;
                    }
                    else{
                        jobbra++;
                    }
                }
                if(bal==-1)
                {
                    jobbra+=balra;
                }
                else{
                    f[i+1][bal]+=balra;

                }
                maradek+=jobbra;

            }

        }
        if(maradek>0)
        {
            f[i+1][bal]+=maradek;

        }

    }
    for(i=0;i<n;i++)
    {
        printf("%li ",f[h][i]);
    }

    return 0;
}